GNU Radio C++ API Reference: gr::fec::code::cc_decoder Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::fec::code::cc_decoder Class Referenceabstract
GNU Radio C++ Signal Processing Blocks » Error Coding and Decoding

Convolutional Code Decoding class. More...

`#include <gnuradio/fec/cc_decoder.h>`

## Public Member Functions
bool | set_frame_size (unsigned int frame_size) override=0
double | rate () override=0
Public Member Functions inherited from gr::fec::generic_decoder
virtual void | generic_work (const void *inbuffer, void *outbuffer)=0
int | unique_id ()
std::string | alias ()
| generic_decoder (void)
| generic_decoder (std::string name)
virtual | ~generic_decoder ()
virtual int | get_input_size ()=0
virtual int | get_output_size ()=0
virtual int | get_history ()
virtual float | get_shift ()
virtual int | get_input_item_size ()
virtual int | get_output_item_size ()
virtual const char * | get_input_conversion ()
virtual const char * | get_output_conversion ()
virtual float | get_iterations ()

## Static Public Member Functions
static generic_decoder::sptr | make (int frame_size, int k, int rate, std::vector< int > polys, int start_state=0, int end_state=-1, cc_mode_t mode=CC_STREAMING, bool padded=false)

## Additional Inherited Members
Public Types inherited from gr::fec::generic_decoder
typedef std::shared_ptr< generic_decoder > | sptr
Public Attributes inherited from gr::fec::generic_decoder
int | my_id
std::string | d_name
Static Public Attributes inherited from gr::fec::generic_decoder
static int | base_unique_id
Protected Attributes inherited from gr::fec::generic_decoder
gr::logger_ptr | d_logger

## Detailed Description

Convolutional Code Decoding class.

This class performs convolutional decoding via the Viterbi algorithm. While it is set up to take variable values for K, rate, and the polynomials, currently, the block is only capable of handling the following settings:

- K = 7
- rate = 1/2 (given as 2 to the constructor)
- polynomials = [109, 79]

This is the well-known convolutional part of the Voyager code implemented in the CCSDS encoder.

The intent of having this FECAPI code classes fully parameterizable is to eventually allow it to take on generic settings, much like the cc_encoder class where the CCSDS settings would be a highly-optimized version of this.

The decoder is set up with a number of bits per frame in the constructor. When not being used in a tagged stream mode, this encoder will only process frames of the length provided here. If used in a tagged stream block, this setting becomes the maximum allowable frame size that the block may process.

The `mode` is a cc_mode_t that specifies how the convolutional encoder will behave and under what conditions.

- 'CC_STREAMING': mode expects an uninterrupted flow of samples into the encoder, and the output stream is continually encoded. This mode is the only mode for this decoder that has a history requirement because it requires rate*(K-1) bits more to finish the decoding properly. This mode does not work with any deployments that do not allow history.

- 'CC_TERMINATED': is a mode designed for packet-based systems. This mode adds rate*(k-1) bits to the output as a way to help flush the decoder.

- 'CC_TAILBITING': is another packet-based method. Instead of adding bits onto the end of the packet, this mode will continue the code between the payloads of packets by pre-initializing the state of the new packet based on the state of the last packet for (k-1) bits.

- 'CC_TRUNCATED': a truncated code always resets the registers to the `start_state` between frames.

A common convolutional encoder uses K=7, Rate=1/2, Polynomials=[109, 79]. This is the Voyager code from NASA:

- 109: b(1101101) --> 1 + x + x^3 + x^4 + x^6
- 79: b(1001111) --> 1 + x^3 + x^4 + x^5 + x^6

## Member Function Documentation

## ◆ make()

generic_decoder::sptr gr::fec::code::cc_decoder::make | ( | int | frame_size,
|  | int | k,
|  | int | rate,
|  | std::vector< int > | polys,
|  | int | start_state = 0,
|  | int | end_state = -1,
|  | cc_mode_t | mode = CC_STREAMING,
|  | bool | padded = false )
| static

Build a convolutional code decoding FEC API object.

Parameters

  frame_size | Number of bits per frame. If using in the tagged stream style, this is the maximum allowable number of bits per frame.
  k | Constraint length (K) of the encoder.
  rate | Inverse of the coder's rate (rate=2 means 2 output bits per 1 input).
  polys | Vector of polynomials as integers.
  start_state | Initialization state of the shift register.
  end_state | Ending state of the shift register.
  mode | cc_mode_t mode of the encoding.
  padded | true if the encoded frame is padded to the nearest byte.

References CC_STREAMING, and rate().

## ◆ rate()

double gr::fec::code::cc_decoder::rate | ( |  | ) |
| overridepure virtual

Returns the coding rate of this encoder.

Implements gr::fec::generic_decoder.

Referenced by make().

## ◆ set_frame_size()

bool gr::fec::code::cc_decoder::set_frame_size | ( | unsigned int | frame_size | ) |
| overridepure virtual

Sets the uncoded frame size to `frame_size`. If `frame_size` is greater than the value given to the constructor, the frame size will be capped by that initial value and this function will return false. Otherwise, it returns true.

Implements gr::fec::generic_decoder.

The documentation for this class was generated from the following file:

- cc_decoder.h